diff --git a/nptl/Makefile b/nptl/Makefile
index 35487593ec..36b59f8a62 100644
--- a/nptl/Makefile
+++ b/nptl/Makefile
@@ -81,7 +81,7 @@ static-only-routines = pthread_atfork
 # We need to provide certain routines for compatibility with existing
 # binaries.
 pthread-compat-wrappers = \
-		      sigwait sigsuspend \
+		      sigsuspend \
 		      recvmsg sendmsg
 
 libpthread-routines = \
@@ -282,7 +282,6 @@ CFLAGS-sem_clockwait.c = -fexceptions -fasynchronous-unwind-tables
 CFLAGS-fcntl.c += -fexceptions -fasynchronous-unwind-tables
 CFLAGS-fcntl64.c += -fexceptions -fasynchronous-unwind-tables
 CFLAGS-lockf.c += -fexceptions
-CFLAGS-sigwait.c += -fexceptions -fasynchronous-unwind-tables
 CFLAGS-recvmsg.c += -fexceptions -fasynchronous-unwind-tables
 CFLAGS-sendmsg.c += -fexceptions -fasynchronous-unwind-tables
 CFLAGS-sigsuspend.c += -fexceptions -fasynchronous-unwind-tables
diff --git a/nptl/Versions b/nptl/Versions
index f5a821c96c..f81a632bdc 100644
--- a/nptl/Versions
+++ b/nptl/Versions
@@ -171,7 +171,6 @@ libpthread {
     sendmsg;
     sigaction;
     siglongjmp;
-    sigwait;
     system;
   }
 
diff --git a/sysdeps/unix/sysv/linux/aarch64/libpthread.abilist b/sysdeps/unix/sysv/linux/aarch64/libpthread.abilist
index 65a6157f48..20d53c9860 100644
--- a/sysdeps/unix/sysv/linux/aarch64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/aarch64/libpthread.abilist
@@ -154,7 +154,6 @@ GLIBC_2.17 sem_wait F
 GLIBC_2.17 sendmsg F
 GLIBC_2.17 sigaction F
 GLIBC_2.17 siglongjmp F
-GLIBC_2.17 sigwait F
 GLIBC_2.17 system F
 GLIBC_2.18 pthread_getattr_default_np F
 GLIBC_2.18 pthread_setattr_default_np F
diff --git a/sysdeps/unix/sysv/linux/alpha/libpthread.abilist b/sysdeps/unix/sysv/linux/alpha/libpthread.abilist
index c07f36a6b5..0f469c8283 100644
--- a/sysdeps/unix/sysv/linux/alpha/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/alpha/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/arc/libpthread.abilist b/sysdeps/unix/sysv/linux/arc/libpthread.abilist
index 1ab2689f9b..8890a4e0ee 100644
--- a/sysdeps/unix/sysv/linux/arc/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/arc/libpthread.abilist
@@ -171,7 +171,6 @@ GLIBC_2.32 sem_unlink F
 GLIBC_2.32 sem_wait F
 GLIBC_2.32 sendmsg F
 GLIBC_2.32 sigaction F
-GLIBC_2.32 sigwait F
 GLIBC_2.32 thrd_create F
 GLIBC_2.32 thrd_detach F
 GLIBC_2.32 thrd_exit F
diff --git a/sysdeps/unix/sysv/linux/arm/be/libpthread.abilist b/sysdeps/unix/sysv/linux/arm/be/libpthread.abilist
index 28fa2c879c..169b8c3857 100644
--- a/sysdeps/unix/sysv/linux/arm/be/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/arm/be/libpthread.abilist
@@ -183,5 +183,4 @@ GLIBC_2.4 sem_wait F
 GLIBC_2.4 sendmsg F
 GLIBC_2.4 sigaction F
 GLIBC_2.4 siglongjmp F
-GLIBC_2.4 sigwait F
 GLIBC_2.4 system F
diff --git a/sysdeps/unix/sysv/linux/arm/le/libpthread.abilist b/sysdeps/unix/sysv/linux/arm/le/libpthread.abilist
index 28fa2c879c..169b8c3857 100644
--- a/sysdeps/unix/sysv/linux/arm/le/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/arm/le/libpthread.abilist
@@ -183,5 +183,4 @@ GLIBC_2.4 sem_wait F
 GLIBC_2.4 sendmsg F
 GLIBC_2.4 sigaction F
 GLIBC_2.4 siglongjmp F
-GLIBC_2.4 sigwait F
 GLIBC_2.4 system F
diff --git a/sysdeps/unix/sysv/linux/csky/libpthread.abilist b/sysdeps/unix/sysv/linux/csky/libpthread.abilist
index 767e19c10e..d4681a8a02 100644
--- a/sysdeps/unix/sysv/linux/csky/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/csky/libpthread.abilist
@@ -165,7 +165,6 @@ GLIBC_2.29 sem_unlink F
 GLIBC_2.29 sem_wait F
 GLIBC_2.29 sendmsg F
 GLIBC_2.29 sigaction F
-GLIBC_2.29 sigwait F
 GLIBC_2.29 thrd_create F
 GLIBC_2.29 thrd_detach F
 GLIBC_2.29 thrd_exit F
diff --git a/sysdeps/unix/sysv/linux/hppa/libpthread.abilist b/sysdeps/unix/sysv/linux/hppa/libpthread.abilist
index 36243c9f1f..bd4405d6b0 100644
--- a/sysdeps/unix/sysv/linux/hppa/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/hppa/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/i386/libpthread.abilist b/sysdeps/unix/sysv/linux/i386/libpthread.abilist
index 1295d86f81..be2fe1c3ae 100644
--- a/sysdeps/unix/sysv/linux/i386/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/i386/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/ia64/libpthread.abilist b/sysdeps/unix/sysv/linux/ia64/libpthread.abilist
index 80c8c452b7..4511c99f45 100644
--- a/sysdeps/unix/sysv/linux/ia64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/ia64/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/m68k/coldfire/libpthread.abilist b/sysdeps/unix/sysv/linux/m68k/coldfire/libpthread.abilist
index 28fa2c879c..169b8c3857 100644
--- a/sysdeps/unix/sysv/linux/m68k/coldfire/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/coldfire/libpthread.abilist
@@ -183,5 +183,4 @@ GLIBC_2.4 sem_wait F
 GLIBC_2.4 sendmsg F
 GLIBC_2.4 sigaction F
 GLIBC_2.4 siglongjmp F
-GLIBC_2.4 sigwait F
 GLIBC_2.4 system F
diff --git a/sysdeps/unix/sysv/linux/m68k/m680x0/libpthread.abilist b/sysdeps/unix/sysv/linux/m68k/m680x0/libpthread.abilist
index 1295d86f81..be2fe1c3ae 100644
--- a/sysdeps/unix/sysv/linux/m68k/m680x0/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/m680x0/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/microblaze/be/libpthread.abilist b/sysdeps/unix/sysv/linux/microblaze/be/libpthread.abilist
index 12f96389bc..459170603f 100644
--- a/sysdeps/unix/sysv/linux/microblaze/be/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/microblaze/be/libpthread.abilist
@@ -156,7 +156,6 @@ GLIBC_2.18 sem_wait F
 GLIBC_2.18 sendmsg F
 GLIBC_2.18 sigaction F
 GLIBC_2.18 siglongjmp F
-GLIBC_2.18 sigwait F
 GLIBC_2.18 system F
 GLIBC_2.28 call_once F
 GLIBC_2.28 cnd_broadcast F
diff --git a/sysdeps/unix/sysv/linux/microblaze/le/libpthread.abilist b/sysdeps/unix/sysv/linux/microblaze/le/libpthread.abilist
index 12f96389bc..459170603f 100644
--- a/sysdeps/unix/sysv/linux/microblaze/le/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/microblaze/le/libpthread.abilist
@@ -156,7 +156,6 @@ GLIBC_2.18 sem_wait F
 GLIBC_2.18 sendmsg F
 GLIBC_2.18 sigaction F
 GLIBC_2.18 siglongjmp F
-GLIBC_2.18 sigwait F
 GLIBC_2.18 system F
 GLIBC_2.28 call_once F
 GLIBC_2.28 cnd_broadcast F
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/libpthread.abilist b/sysdeps/unix/sysv/linux/mips/mips32/libpthread.abilist
index a3d38c87cc..99a0a8e9e1 100644
--- a/sysdeps/unix/sysv/linux/mips/mips32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips32/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.11 pthread_sigqueue F
 GLIBC_2.12 pthread_getname_np F
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/libpthread.abilist b/sysdeps/unix/sysv/linux/mips/mips64/libpthread.abilist
index a3d38c87cc..99a0a8e9e1 100644
--- a/sysdeps/unix/sysv/linux/mips/mips64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips64/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.11 pthread_sigqueue F
 GLIBC_2.12 pthread_getname_np F
diff --git a/sysdeps/unix/sysv/linux/nios2/libpthread.abilist b/sysdeps/unix/sysv/linux/nios2/libpthread.abilist
index ef585dd6ad..c2516d20b2 100644
--- a/sysdeps/unix/sysv/linux/nios2/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/nios2/libpthread.abilist
@@ -156,7 +156,6 @@ GLIBC_2.21 sem_wait F
 GLIBC_2.21 sendmsg F
 GLIBC_2.21 sigaction F
 GLIBC_2.21 siglongjmp F
-GLIBC_2.21 sigwait F
 GLIBC_2.21 system F
 GLIBC_2.28 call_once F
 GLIBC_2.28 cnd_broadcast F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/libpthread.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc32/libpthread.abilist
index 509954e8a3..b69b5885bd 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc32/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/be/libpthread.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc64/be/libpthread.abilist
index d4c0f30062..a75d459318 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/be/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/be/libpthread.abilist
@@ -154,7 +154,6 @@ GLIBC_2.3 sem_wait F
 GLIBC_2.3 sendmsg F
 GLIBC_2.3 sigaction F
 GLIBC_2.3 siglongjmp F
-GLIBC_2.3 sigwait F
 GLIBC_2.3 system F
 GLIBC_2.3.2 pthread_cond_broadcast F
 GLIBC_2.3.2 pthread_cond_signal F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libpthread.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libpthread.abilist
index 65a6157f48..20d53c9860 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libpthread.abilist
@@ -154,7 +154,6 @@ GLIBC_2.17 sem_wait F
 GLIBC_2.17 sendmsg F
 GLIBC_2.17 sigaction F
 GLIBC_2.17 siglongjmp F
-GLIBC_2.17 sigwait F
 GLIBC_2.17 system F
 GLIBC_2.18 pthread_getattr_default_np F
 GLIBC_2.18 pthread_setattr_default_np F
diff --git a/sysdeps/unix/sysv/linux/riscv/rv32/libpthread.abilist b/sysdeps/unix/sysv/linux/riscv/rv32/libpthread.abilist
index 2dec98bb41..f954201a88 100644
--- a/sysdeps/unix/sysv/linux/riscv/rv32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/riscv/rv32/libpthread.abilist
@@ -171,7 +171,6 @@ GLIBC_2.33 sem_unlink F
 GLIBC_2.33 sem_wait F
 GLIBC_2.33 sendmsg F
 GLIBC_2.33 sigaction F
-GLIBC_2.33 sigwait F
 GLIBC_2.33 thrd_create F
 GLIBC_2.33 thrd_detach F
 GLIBC_2.33 thrd_exit F
diff --git a/sysdeps/unix/sysv/linux/riscv/rv64/libpthread.abilist b/sysdeps/unix/sysv/linux/riscv/rv64/libpthread.abilist
index e85d94d7d4..8e4188c6f9 100644
--- a/sysdeps/unix/sysv/linux/riscv/rv64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/riscv/rv64/libpthread.abilist
@@ -154,7 +154,6 @@ GLIBC_2.27 sem_unlink F
 GLIBC_2.27 sem_wait F
 GLIBC_2.27 sendmsg F
 GLIBC_2.27 sigaction F
-GLIBC_2.27 sigwait F
 GLIBC_2.28 call_once F
 GLIBC_2.28 cnd_broadcast F
 GLIBC_2.28 cnd_destroy F
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/libpthread.abilist b/sysdeps/unix/sysv/linux/s390/s390-32/libpthread.abilist
index 5756f635ff..049e962bb0 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/s390/s390-64/libpthread.abilist b/sysdeps/unix/sysv/linux/s390/s390-64/libpthread.abilist
index d8fa781856..8c09de2f17 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/s390/s390-64/libpthread.abilist
@@ -136,7 +136,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/sh/be/libpthread.abilist b/sysdeps/unix/sysv/linux/sh/be/libpthread.abilist
index 36243c9f1f..bd4405d6b0 100644
--- a/sysdeps/unix/sysv/linux/sh/be/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/sh/be/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/sh/le/libpthread.abilist b/sysdeps/unix/sysv/linux/sh/le/libpthread.abilist
index 36243c9f1f..bd4405d6b0 100644
--- a/sysdeps/unix/sysv/linux/sh/le/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/sh/le/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc32/libpthread.abilist b/sysdeps/unix/sysv/linux/sparc/sparc32/libpthread.abilist
index c07f36a6b5..0f469c8283 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/sparc/sparc32/libpthread.abilist
@@ -66,7 +66,6 @@ GLIBC_2.0 sem_wait F
 GLIBC_2.0 sendmsg F
 GLIBC_2.0 sigaction F
 GLIBC_2.0 siglongjmp F
-GLIBC_2.0 sigwait F
 GLIBC_2.0 system F
 GLIBC_2.1 __libc_allocate_rtsig F
 GLIBC_2.1 __libc_current_sigrtmax F
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc64/libpthread.abilist b/sysdeps/unix/sysv/linux/sparc/sparc64/libpthread.abilist
index 80c8c452b7..4511c99f45 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/sparc/sparc64/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2 sem_wait F
 GLIBC_2.2 sendmsg F
 GLIBC_2.2 sigaction F
 GLIBC_2.2 siglongjmp F
-GLIBC_2.2 sigwait F
 GLIBC_2.2 system F
 GLIBC_2.2.3 __libpthread_version_placeholder F
 GLIBC_2.2.6 __libpthread_version_placeholder F
diff --git a/sysdeps/unix/sysv/linux/x86_64/64/libpthread.abilist b/sysdeps/unix/sysv/linux/x86_64/64/libpthread.abilist
index 7efecf5df6..a08dd3d0f6 100644
--- a/sysdeps/unix/sysv/linux/x86_64/64/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/64/libpthread.abilist
@@ -134,7 +134,6 @@ GLIBC_2.2.5 sem_wait F
 GLIBC_2.2.5 sendmsg F
 GLIBC_2.2.5 sigaction F
 GLIBC_2.2.5 siglongjmp F
-GLIBC_2.2.5 sigwait F
 GLIBC_2.2.5 system F
 GLIBC_2.2.6 __libpthread_version_placeholder F
 GLIBC_2.28 call_once F
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/libpthread.abilist b/sysdeps/unix/sysv/linux/x86_64/x32/libpthread.abilist
index 78ada58f42..465c28d76f 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/libpthread.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/libpthread.abilist
@@ -154,7 +154,6 @@ GLIBC_2.16 sem_wait F
 GLIBC_2.16 sendmsg F
 GLIBC_2.16 sigaction F
 GLIBC_2.16 siglongjmp F
-GLIBC_2.16 sigwait F
 GLIBC_2.16 system F
 GLIBC_2.18 pthread_getattr_default_np F
 GLIBC_2.18 pthread_setattr_default_np F