diff --git a/nptl/Makefile b/nptl/Makefile
index bf5ca2e6d2..42d602a870 100644
--- a/nptl/Makefile
+++ b/nptl/Makefile
@@ -213,6 +213,7 @@ libpthread-routines = \
   sem_unlink \
   sem_wait \
   sigaction \
+  libc_sigaction \
   tpp \
   unwind \
   unwind-forcedunwind \
diff --git a/signal/Makefile b/signal/Makefile
index 3d8cab1f50..99889a53a4 100644
--- a/signal/Makefile
+++ b/signal/Makefile
@@ -35,7 +35,7 @@ headers := signal.h sys/signal.h \
 	   bits/sigstksz.h
 
 routines	:= signal raise killpg \
-		   sigaction sigprocmask kill \
+		   sigaction libc_sigaction sigprocmask kill \
 		   sigpending sigsuspend sigwait \
 		   sigblock sigsetmask sigpause sigvec \
 		   sigstack sigaltstack sigintr \
diff --git a/signal/libc_sigaction.c b/signal/libc_sigaction.c
new file mode 100644
index 0000000000..c25913b9bd
--- /dev/null
+++ b/signal/libc_sigaction.c
@@ -0,0 +1,32 @@
+/* Internal sigaction definitions.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <signal.h>
+
+/* If ACT is not NULL, change the action for SIG to *ACT.
+   If OACT is not NULL, put the old action for SIG in *OACT.  */
+int
+__libc_sigaction (int sig, const struct sigaction *act,
+		  struct sigaction *oact)
+{
+  __set_errno (ENOSYS);
+  return -1;
+}
+stub_warning (libc_sigaction)
+libc_hidden_def (__libc_sigaction)
diff --git a/signal/sigaction.c b/signal/sigaction.c
index 3bfc17945c..8d9f755ccc 100644
--- a/signal/sigaction.c
+++ b/signal/sigaction.c
@@ -17,7 +17,7 @@
 
 #include <errno.h>
 #include <signal.h>
-
+#include <internal-signals.h>
 
 /* If ACT is not NULL, change the action for SIG to *ACT.
    If OACT is not NULL, put the old action for SIG in *OACT.  */
@@ -30,10 +30,7 @@ __sigaction (int sig, const struct sigaction *act, struct sigaction *oact)
       return -1;
     }
 
-  __set_errno (ENOSYS);
-  return -1;
+  return __libc_sigaction (sig, act, oact);
 }
 libc_hidden_def (__sigaction)
-stub_warning (sigaction)
-
 weak_alias (__sigaction, sigaction)
diff --git a/sysdeps/mach/hurd/sigaction.c b/sysdeps/mach/hurd/libc_sigaction.c
similarity index 89%
rename from sysdeps/mach/hurd/sigaction.c
rename to sysdeps/mach/hurd/libc_sigaction.c
index ab91e122b9..29547e2d6a 100644
--- a/sysdeps/mach/hurd/sigaction.c
+++ b/sysdeps/mach/hurd/libc_sigaction.c
@@ -24,16 +24,15 @@
 /* If ACT is not NULL, change the action for SIG to *ACT.
    If OACT is not NULL, put the old action for SIG in *OACT.  */
 int
-__sigaction (int sig, const struct sigaction *act, struct sigaction *oact)
+__libc_sigaction (int sig, const struct sigaction *act,
+		  struct sigaction *oact)
 {
   struct hurd_sigstate *ss;
   struct sigaction a, old;
   sigset_t pending;
 
-  if (sig <= 0 || sig >= NSIG
-      || (act != NULL && act->sa_handler != SIG_DFL
-	  && ((__sigmask (sig) & _SIG_CANT_MASK)
-	      || act->sa_handler == SIG_ERR)))
+  if (act != NULL && act->sa_handler != SIG_DFL
+      && ((__sigmask (sig) & _SIG_CANT_MASK) || act->sa_handler == SIG_ERR))
     {
       errno = EINVAL;
       return -1;
@@ -87,5 +86,4 @@ __sigaction (int sig, const struct sigaction *act, struct sigaction *oact)
 
   return 0;
 }
-libc_hidden_def (__sigaction)
-weak_alias (__sigaction, sigaction)
+libc_hidden_def (__libc_sigaction)
diff --git a/sysdeps/unix/sysv/linux/aarch64/sigaction.c b/sysdeps/unix/sysv/linux/aarch64/libc_sigaction.c
similarity index 95%
rename from sysdeps/unix/sysv/linux/aarch64/sigaction.c
rename to sysdeps/unix/sysv/linux/aarch64/libc_sigaction.c
index 6f44866ce1..a2a2a17fe9 100644
--- a/sysdeps/unix/sysv/linux/aarch64/sigaction.c
+++ b/sysdeps/unix/sysv/linux/aarch64/libc_sigaction.c
@@ -27,4 +27,4 @@
 #define RESET_SA_RESTORER(act, kact)		\
   (act)->sa_restorer = (kact)->sa_restorer;
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/arc/sigaction.c b/sysdeps/unix/sysv/linux/arc/libc_sigaction.c
similarity index 95%
rename from sysdeps/unix/sysv/linux/arc/sigaction.c
rename to sysdeps/unix/sysv/linux/arc/libc_sigaction.c
index 2807f74b1b..26da42f04f 100644
--- a/sysdeps/unix/sysv/linux/arc/sigaction.c
+++ b/sysdeps/unix/sysv/linux/arc/libc_sigaction.c
@@ -28,4 +28,4 @@ extern void __default_rt_sa_restorer (void);
 
 #define RESET_SA_RESTORER(act, kact)
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/arm/sigaction.c b/sysdeps/unix/sysv/linux/arm/libc_sigaction.c
similarity index 96%
rename from sysdeps/unix/sysv/linux/arm/sigaction.c
rename to sysdeps/unix/sysv/linux/arm/libc_sigaction.c
index 76a9abebf3..de061312d5 100644
--- a/sysdeps/unix/sysv/linux/arm/sigaction.c
+++ b/sysdeps/unix/sysv/linux/arm/libc_sigaction.c
@@ -36,4 +36,4 @@ extern void __default_rt_sa_restorer (void);
 #define RESET_SA_RESTORER(act, kact)				\
   (act)->sa_restorer = (kact)->sa_restorer;
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/i386/sigaction.c b/sysdeps/unix/sysv/linux/i386/libc_sigaction.c
similarity index 97%
rename from sysdeps/unix/sysv/linux/i386/sigaction.c
rename to sysdeps/unix/sysv/linux/i386/libc_sigaction.c
index 46aeca252d..1d6457612a 100644
--- a/sysdeps/unix/sysv/linux/i386/sigaction.c
+++ b/sysdeps/unix/sysv/linux/i386/libc_sigaction.c
@@ -39,7 +39,7 @@ extern void restore (void) asm ("__restore") attribute_hidden;
 #define RESET_SA_RESTORER(act, kact) \
   (act)->sa_restorer = (kact)->sa_restorer
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
 
 /* NOTE: Please think twice before making any changes to the bits of
    code below.  GDB needs some intimate knowledge about it to
diff --git a/sysdeps/unix/sysv/linux/sigaction.c b/sysdeps/unix/sysv/linux/libc_sigaction.c
similarity index 98%
rename from sysdeps/unix/sysv/linux/sigaction.c
rename to sysdeps/unix/sysv/linux/libc_sigaction.c
index 38088f9a85..21fe657d1f 100644
--- a/sysdeps/unix/sysv/linux/sigaction.c
+++ b/sysdeps/unix/sysv/linux/libc_sigaction.c
@@ -70,5 +70,3 @@ __libc_sigaction (int sig, const struct sigaction *act, struct sigaction *oact)
   return result;
 }
 libc_hidden_def (__libc_sigaction)
-
-#include <nptl/sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c b/sysdeps/unix/sysv/linux/sparc/sparc32/libc_sigaction.c
similarity index 96%
rename from sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c
rename to sysdeps/unix/sysv/linux/sparc/sparc32/libc_sigaction.c
index f1e07fbb7c..09a052fc05 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c
+++ b/sysdeps/unix/sysv/linux/sparc/sparc32/libc_sigaction.c
@@ -34,4 +34,4 @@ void __sigreturn_stub (void);
 	: 0,						\
   (sigsetsize)
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc64/sigaction.c b/sysdeps/unix/sysv/linux/sparc/sparc64/libc_sigaction.c
similarity index 95%
rename from sysdeps/unix/sysv/linux/sparc/sparc64/sigaction.c
rename to sysdeps/unix/sysv/linux/sparc/sparc64/libc_sigaction.c
index 2e7f940a4e..6cfcf0a4cb 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc64/sigaction.c
+++ b/sysdeps/unix/sysv/linux/sparc/sparc64/libc_sigaction.c
@@ -29,4 +29,4 @@ void __rt_sigreturn_stub (void);
   (((unsigned long) &__rt_sigreturn_stub) - 8),	\
   (sigsetsize)
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
diff --git a/sysdeps/unix/sysv/linux/x86_64/sigaction.c b/sysdeps/unix/sysv/linux/x86_64/libc_sigaction.c
similarity index 99%
rename from sysdeps/unix/sysv/linux/x86_64/sigaction.c
rename to sysdeps/unix/sysv/linux/x86_64/libc_sigaction.c
index b295037db7..21367e97c1 100644
--- a/sysdeps/unix/sysv/linux/x86_64/sigaction.c
+++ b/sysdeps/unix/sysv/linux/x86_64/libc_sigaction.c
@@ -30,7 +30,7 @@ extern void restore_rt (void) asm ("__restore_rt") attribute_hidden;
 
 #include <kernel_sigaction.h>
 
-#include <sysdeps/unix/sysv/linux/sigaction.c>
+#include <sysdeps/unix/sysv/linux/libc_sigaction.c>
 
 /* NOTE: Please think twice before making any changes to the bits of
    code below.  GDB needs some intimate knowledge about it to